module SQLBeauty where 
import qualified SQLModel as SQL
import PPrint 
import List

isIndenter (SQL.Indenter _) = True
isIndenter _              = False

equalIndenting x y =  (isIndenter x) == (isIndenter y)

groupedSQL xs = groupBy equalIndenting xs

beautyGroup isFirst xs@(x:_) = 
	if (isIndenter x) 
		then vsep (map beautyItem xs) 
		else indent (if isFirst then 0 else 4) (hsep (map beautyItem xs))

beauty sql = vsep ((beautyGroup True x):(map (beautyGroup False) xs))
	where x:xs = groupedSQL sql

beautyItem (SQL.Indenter s) = text s
beautyItem (SQL.Text s) = text s
beautyItem (SQL.Parens x) = text "(" <$> (indent 4 (beauty x)) <$> text ")" 